#! /usr/bin/perl -w

# Luis Lopez


use File::Find;
use File::stat;

%diskSpace = ();

find(\&wanted, @ARGV);   # Find files inside the specified directory recusively

foreach $key(sort keys %diskSpace) {  # print the user space, followed by username in alphabetical order
   print "$diskSpace{$key} $key\n";
}

sub wanted {
   $fileOwner = stat($_) or die "No $_\n";   # get the file stats
   $userName = getpwuid($fileOwner->uid);   # get the username from uid

   $diskSpace{$userName} += $fileOwner->size / 1024;  #add the size of the file (in KB) to the hash variable
}
